<template>
  <div class="app-container">

    <!-- 搜索工作栏 -->
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="商品编码" prop="productCode">
        <el-input v-model="queryParams.productCode" placeholder="请输入商品编码" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>

      <el-form-item label="海关编码" prop="customsCode">
        <el-input v-model="queryParams.customsCode" placeholder="请输入海关编码" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>

      <el-form-item label="商品名称" prop="titleZh">
        <el-input v-model="queryParams.titleZh" placeholder="请输入商品名称" clearable @keyup.enter.native="handleQuery"/>
      </el-form-item>
      
      <el-form-item label="商品类型" prop="typeId">
        <el-select v-model="queryParams.typeId" placeholder="选择商品类型" clearable>
          <el-option v-for="type in typeList" :key="type.id" :label="type.titleZh" :value="type.id"/>
        </el-select>
      </el-form-item>

      <el-form-item label="商品特性" prop="attrId">
        <el-select v-model="queryParams.attrId" placeholder="选择商品特性" clearable>
          <el-option v-for="attr in attrList" :key="attr.id" :label="attr.attrName" :value="attr.id"/>
        </el-select>
      </el-form-item>
      
      <el-form-item label="审核状态" prop="auditStatus">
        <el-select v-model="queryParams.auditStatus" placeholder="选择审核状态" clearable>
          <el-option v-for="auditStatusItem in auditStatusDictDatas" :key="auditStatusItem.id" :label="auditStatusItem.label" :value="auditStatusItem.value"/>
        </el-select>
      </el-form-item>

      <el-form-item label="上架状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="选择上架状态" clearable>
          <el-option v-for="statusItem in statusDictDatas" :key="statusItem.id" :label="statusItem.value == CommonStatusEnum.ENABLE ? '已上架' : '已下架'" :value="statusItem.value"/>
        </el-select>
      </el-form-item>
      
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <!-- 操作工具栏 -->
    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                   v-hasPermi="['ecw:product:create']">新增</el-button>
      </el-col>
      
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <!-- 列表 -->
    <el-table v-loading="loading" :data="list">
      <el-table-column label="商品编号" align="center" prop="id" />
      <el-table-column label="商品类型" align="center" prop="typeId">
        <template slot-scope="scope">
          <span>{{ getTypeName(scope.row.typeId) }}</span>
        </template>
      </el-table-column>
      <el-table-column label="海关编码" align="center" prop="customsCode" />
      <el-table-column label="中文标题" align="center" prop="titleZh" />
      <el-table-column label="英文标题" align="center" prop="titleEn" />
      <el-table-column label="商品特性" align="center" prop="attrId">
        <template slot-scope="scope">
          <span>{{ getAttrName(scope.row.attrId) }}</span>
        </template>
      </el-table-column>

      <el-table-column prop="auditStatus" align="center" label="是否审核" width="120">
        <template slot-scope="scope">
           <el-select v-model="scope.row.auditStatus" @change="handleStatusChange(scope.row, 'auditStatus')">
              <el-option v-for="auditStatusItem in auditStatusDictDatas" :key="auditStatusItem.id" :label="auditStatusItem.label" :value="parseInt(auditStatusItem.value)"/>
           </el-select>
        </template>
      </el-table-column>
      
      <el-table-column prop="status" align="center" label="状态" width="120">
        <template slot-scope="scope">
           <el-select v-model="scope.row.status" @change="handleStatusChange(scope.row, 'status')">
              <el-option v-for="statusItem in statusDictDatas" :key="statusItem.id" :label="statusItem.value == CommonStatusEnum.ENABLE + '' ? '已上架' : '已下架'" :value="parseInt(statusItem.value)"/>
           </el-select>
        </template>
      </el-table-column>

      
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">

          <el-button size="mini" type="text" @click="toPriceManager(scope.row)"
                     v-hasPermi="['ecw:product-price:query']">路线价格</el-button>

          <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                     v-hasPermi="['ecw:product:update']">修改</el-button>
          <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                     v-hasPermi="['ecw:product:delete']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    <!-- 分页组件 -->
    <pagination v-show="total > 0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                @pagination="getList"/>

    <!-- 对话框(添加 / 修改) -->
    <el-dialog :title="title" :visible.sync="open" width="550px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="110px">
        <el-form-item label="商品类型" prop="typeId">
          <el-select v-model="form.typeId" placeholder="选择商品类型" clearable>
            <el-option v-for="type in typeList" :key="type.id" :label="type.titleZh" :value="type.id"/>
          </el-select>
        </el-form-item>

        <el-form-item label="中文标题" prop="titleZh">
          <el-input v-model="form.titleZh" placeholder="请输入中文标题" />
        </el-form-item>

        <el-form-item label="英文标题" prop="titleEn">
          <el-input v-model="form.titleEn" placeholder="请输入英文标题" />
        </el-form-item>

        <el-form-item label="商品图片" prop="img">
          <el-col :span="8">
            <el-input v-model="form.imgs"  placeholder="请上传图片" disabled/>
          </el-col>

           <el-upload action="#" :http-request="requestUpload" :show-file-list="false" :before-upload="beforeUpload">
            <el-button size="small">
              上传图片
              <i class="el-icon-upload el-icon--right"></i>
            </el-button>
          </el-upload>

        </el-form-item>

        <el-form-item label="商品编码" prop="productCode">
          <el-input v-model="form.productCode" placeholder="请输入商品编码" />
        </el-form-item>

        <el-form-item label="海关编码" prop="customsCode">
          <el-input v-model="form.customsCode" placeholder="请输入海关编码" />
        </el-form-item>

        <el-form-item label="商品特性" prop="attrArray">
          <el-select v-model="form.attrArray" placeholder="选择商品特性" clearable multiple>
            <el-option v-for="attr in attrList" :key="attr.id" :label="attr.attrName" :value="attr.id"/>
         </el-select>
        </el-form-item>

        <el-form-item label="商品材质" prop="materialType">
          <el-select v-model="form.materialType" placeholder="选择商品材质" clearable>
            <el-option v-for="materialItem in materialList" :key="materialItem.value" :label="materialItem.label" :value="materialItem.value"/>
          </el-select>
        </el-form-item>

        <el-form-item label="出运要求" prop="requirements">
          <el-checkbox v-model="form.requirements" :checked="form.requirements===1? true:false" 
          :true-label="1" :false-label="0">证书要求（支持多证书）</el-checkbox>
        </el-form-item>

        <el-form-item label="包装要求" prop="packaging">
          <el-select v-model="form.packaging" placeholder="选择包装要求" clearable>
            <el-option v-for="packageItem in packagingList" :key="packageItem.value" :label="packageItem.label" :value="packageItem.value"/>
          </el-select>
        </el-form-item>

        <el-form-item label="默认货柜位置" prop="containerLocation">
          <el-select v-model="form.containerLocation" placeholder="选择货柜位置" clearable>
            <el-option v-for="locationItem in locationList" :key="locationItem.value" :label="locationItem.label" :value="locationItem.value"/>
          </el-select>
        </el-form-item>

        <el-form-item label="默认方数要求" prop="square">
          <el-input v-model.number="form.square" type="number">
            <!-- <template slot="append">立方米</template> -->
          </el-input>
        </el-form-item>

        <el-form-item label="需要预约入仓" prop="needBook">
          <el-radio v-model.number="form.needBook" :label="1">是</el-radio>
          <el-radio v-model.number="form.needBook" :label="0">否</el-radio>
        </el-form-item>

        <el-form-item label="每日入仓上限" prop="dayLimit">
          <el-input v-model.number="form.dayLimit" type="number">
            <template slot="append">立方米</template>
          </el-input>
        </el-form-item>
        
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { createProduct, updateProduct, deleteProduct, getProduct, getProductPage, exportProductExcel } from "@/api/ecw/product";
import { getProductAttrList } from "@/api/ecw/productAttr";
import { getProductTypeList } from "@/api/ecw/productType";
import { getDictDatas, DICT_TYPE } from '@/utils/dict';
import { CommonStatusEnum, AuditStatusEnum } from '@/utils/constants';
import { uploadFile } from "@/api/infra/file";

export default {
  name: "ProductList",
  components: {
  },
  data() {
    return {
      //特性列表
      attrList:[],
      //类型列表
      typeList:[],
      //材质列表
      materialList:[],
      //包装列表
      packagingList:[],
      //货柜位置
      locationList:[],

      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 产品列表
      list: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      dateRangeCreateTime: [],
      // 查询参数
      queryParams: {
        pageNo: 1,
        pageSize: 10,
        typeId: null,
        attrId: null,
        titleZh: null,
        titleEn: null,
        auditStatus: null,
        status: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        typeId: [{ required: true, message: "商品类型不能为空", trigger: "change" }],
        attrArray: [{ required: true, message: "商品特性不能为空", trigger: "change" }],
        titleZh: [{ required: true, message: "中文标题不能为空", trigger: "blur" }],
        titleEn: [{ required: true, message: "英文标题不能为空", trigger: "blur" }],
        materialType:[{ required: true, message: "商品材质不能为空", trigger: "blur" }],
        packaging:[{ required: true, message: "包装要求不能为空", trigger: "blur" }],
        containerLocation:[{ required: true, message: "默认货柜位置不能为空", trigger: "blur" }],
        square:[{ required: true, message: "默认方数不能为空", trigger: "blur" }],
        needBook:[{ required: true, message: "预约入仓不能为空", trigger: "blur" }],
      },

      CommonStatusEnum: CommonStatusEnum,
      AuditStatusEnum: AuditStatusEnum,
      statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS),
      auditStatusDictDatas: getDictDatas(DICT_TYPE.AUDIT_STATUS),
      materialList: getDictDatas(DICT_TYPE.ECW_PRODUCT_MATERIAL),
      packagingList: getDictDatas(DICT_TYPE.ECW_PACKAGING_TYPE),
      locationList: getDictDatas(DICT_TYPE.ECW_CONTAINER_LOCATION)
    };
  },

  computed: {
    getTypeName() {
      return typeId => {
        for(let index in this.typeList) {
          let typeItem = this.typeList[index];
          if(typeItem.id == typeId) {
            return typeItem.titleZh;
          }
        }
      }
    },

    getAttrName() {
      return attrIds => {
        let productAttrArray = [];
        let attrArray = attrIds.split(',');
        for(let attrIndex in attrArray) {
          let attrId = attrArray[attrIndex];
          for(let index in this.attrList) {
            let attrItem = this.attrList[index];
            if(attrItem.id == attrId) {
              productAttrArray.push(attrItem.attrName);
            }
          }
        }
        return productAttrArray.join(',');
      }
    },
  },


  created() {
    let typeId = this.$route.query.typeId;
    if(typeId) {
      this.queryParams.typeId = parseInt(typeId);
    }
    this.getAttrList();
    this.getTypeList();
    this.getList();
  },
  methods: {
    /** 获取产品属性列表 */
    getAttrList() {
      getProductAttrList().then(response => {
          this.attrList = response.data;
      })
    },

    /** 获取产品类型列表 */
    getTypeList() {
      getProductTypeList().then(response => {
        this.typeList = response.data;
      })
    },

    /**跳转价格管理 */
    toPriceManager(row) {
      /* localStorage.setItem('product', JSON.stringify(row));
      localStorage.setItem('typeList', JSON.stringify(this.typeList)); */
      this.$router.push({
        name:'ProductPrice',
        query: {
          product_id: row.id,
          product_type: row.typeId
        }
      })
    },

    handleStatusChange(row, statusType) {
      updateProduct(row).then(() => {
        this.$modal.msgSuccess("修改成功");
      }).catch(function() {
        if(statusType == 'status') {
          row.status = row.status === CommonStatusEnum.ENABLE ? CommonStatusEnum.DISABLE : CommonStatusEnum.ENABLE;
        } else {
          row.auditStatus = row.auditStatus === AuditStatusEnum.PASS ? AuditStatusEnum.NOT_PASS : AuditStatusEnum.PASS;
        }
        
      });
    },

    /** 查询列表 */
    getList() {
      this.loading = true;
      // 处理查询参数
      let params = {...this.queryParams};
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行查询
      getProductPage(params).then(response => {
        this.list = response.data.list;
        this.total = response.data.total;
        this.loading = false;
      });
    },
    /** 取消按钮 */
    cancel() {
      this.open = false;
      this.reset();
    },
    /** 表单重置 */
    reset() {
      this.form = {
        id: undefined,
        typeId: undefined,
        attrArray: undefined,
        attrId: undefined,
        titleZh: undefined,
        titleEn: undefined,
        auditStatus: undefined,
        status: undefined,
        requirements:0,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNo = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.dateRangeCreateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加商品";
      if(this.queryParams.typeId) {
        this.form.typeId = this.queryParams.typeId;
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id;
      getProduct(id).then(response => {
        this.form = response.data;
        let attrArray = this.form.attrId.split(',');
        for(let index in attrArray) {
          let value = attrArray[index];
          attrArray[index] = parseInt(value);
        }
        this.form.attrArray = attrArray;
        this.open = true;
        this.title = "修改商品";
      });
    },

    /** 提交按钮 */
    submitForm() {
      console.log(this.form);
      this.$refs["form"].validate(valid => {
        if (!valid) {
          return;
        }
        //商品特性转字符串
        this.form.attrId = this.form.attrArray.join(',');

        // 修改的提交
        if (this.form.id != null) {
          updateProduct(this.form).then(response => {
            this.$modal.msgSuccess("修改成功");
            this.open = false;
            this.getList();
          });
          return;
        }
        // 添加的提交
        createProduct(this.form).then(response => {
          this.$modal.msgSuccess("新增成功");
          this.open = false;
          this.getList();
        });
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const id = row.id;
      this.$modal.confirm('是否确认删除商品编号为"' + id + '"的数据项?').then(function() {
          return deleteProduct(id);
        }).then(() => {
          this.getList();
          this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      // 处理查询参数
      let params = {...this.queryParams};
      params.pageNo = undefined;
      params.pageSize = undefined;
      this.addBeginAndEndTime(params, this.dateRangeCreateTime, 'createTime');
      // 执行导出
      this.$modal.confirm('是否确认导出所有商品数据项?').then(() => {
          this.exportLoading = true;
          return exportProductExcel(params);
        }).then(response => {
          this.$download.excel(response, '${table.classComment}.xls');
          this.exportLoading = false;
        }).catch(() => {});
    },

    // 覆盖默认的上传行为
    requestUpload() {
    },
    // 上传预处理
    beforeUpload(file) {
      if (file.type.indexOf("image/") == -1) {
        this.$modal.msgError("文件格式错误，请上传图片类型,如：JPG，PNG后缀的文件。");
      } else {
        //上传
        let formData = new FormData();
        formData.append("file", file);
        formData.append("path", this.uuid());
        uploadFile(formData).then(response => {
          this.$set(this.form, 'imgs', response.data);
          // this.form.img = response.data;
        })
      }
    },

    uuid() {
      var s = [];
      var hexDigits = "0123456789abcdef";
      for (var i = 0; i < 36; i++) {
          s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
      }
      s[14] = "4"; // bits 12-15 of the time_hi_and_version field to 0010
      s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01
      s[8] = s[13] = s[18] = s[23] = "-";

      var uuid = s.join("");
      return uuid;
    },
  }
};
</script>
